### Information about this plugin

This plugin is a simple to use All-in-One approach developed by iubenda that helps with generating the privacy policy text, the cookie banner and the blocking management of cookies that require prior consent by users on your own site. This plugin works with the Iubenda Cookie Law Solution and allows to block the most common widgets and third party cookies to comply with cookie laws, particularly with the Italian cookie law implementation in mind (for the time being).

- The plugin automatically inserts the iubenda cookie law kit code in the head of every page of the site
- It allows to manually block all the remaining resources, without the need of direct intervention on the code
- It handles the display of cookie banners and cookie policy, registers cookie consent and saves user preferences about the use of cookies for the future
- It displays a clean page (without banner) to users who have already provided their consent
- It detects bots/spiders and serves them a clean page

The plugin is currently capable of automatically detecting and blocking the following scripts:

* Google Analytics
* Google Maps
* Google AdSense
* Google ReCaptcha
* Google Site Search
* Google Tag Manager
* Google oAuth
* Google+ widgets
* Twitter widgets
* Facebook widgets
* Facebook Comments
* YouTube
* Vimeo
* Linkedin widgets
* ShareThis widgets
* Instagram widgets
* AddThis widgets
* Pinterest widgets
* PayPal widgets
* Disqus
* Optimizely
* Neodata
* Criteo
* Outbrain
* Headway
* Codepen
* Freshchat
* Uservoice
* AdRoll
* Olark
* Segment
* Kissmetrics
* Mixpanel
* Pingdom
* Bing
* Elevio

### Some background information

If you have European users you will know the problem: you need to obtain consent for the usage of many types of cookies and you need to manage that consent. Now even Google forces cookie consent onto users of Google AdSense, DoubleClick for Publishers, and DoubleClick Ad Exchange (and even Google Analytics in some cases). Time to get started with the required cookie banner. Iubenda and its Cookie Law Solution extension for Magento help remove these complex tasks with a couple of clicks. This extension works with the Iubenda Cookie Law Solution, displays a cookie banner in 8 languages and saves consent for returning users.

Which languages does iubenda work in currently?

- English
- Italian
- French
- Spanish
- Portuguese (Brazilian)
- German
- Dutch
- Russian

### Compatibility

The Magento extensions is compatible with all versions of Magento 1.9.x

### Installation and activation

To install the extension first you need to copy content of zip file to the required Magento directory: /magento/app/

Then you have 2 ways to install the extension:

##### Admin installation
In the admin panel go to System -> Configuration -> Advanced -> Advanced. Now in "Disable Modules Output" box find Iubenda_Cookiesolution and enable it.
If you have problems finding the Iubenda_Cookiesolution clear cache in System -> Cache Management and try again.

##### Shell installation
This method requires access to the server shell. All you need to to is to type "php bin/magento setup:upgrade" there. 
This command should do the trick. It checks all of the modules and launches schema installation or updating process.

### Configuration
- Access the Admin panel (http://example.com/admin123/) and log in
- Navigate to System -> Configuration -> Services -> iubenda Cookie Solution
- Configure the extensions by copying the JavaScript code from your iubenda.com account
- Save the configuration
- Clear the store cache

### Use
Once configured, the plugin will begin to show the banner on which your cookie policy will be shown/linked to users that visit your site for the first time without the need for any other further configurations. Moreover, the plugin will recognize and automatically block the cookies installed by all the YouTube video players and social widgets - like the Facebook Like button - present on your site.

Important note: our Magento extensions blocks all scripts by Facebook, Twitter, G+, YouTube iframes automatically that are generated on the server side (therefore returned by PHP by Magento). Scripts that are inserted into the page via Javascript after the loading process of that page aren't and can't be blocked automatically; The other scripts which aren't yet automatically blocked - and that install cookies which require blocking prior to their installation - can be "wrapped" as illustrated in this help post https://www.iubenda.com/en/help/1229

### Manual Use

How to make the plugin manually work for a Facebook button?

    <!--IUB-COOKIE-BLOCK-START-->
    <script>
    (function(d, s, id) {
     var js, fjs = d.getElementsByTagName(s)[0];
     if (d.getElementById(id)) return;
     js = d.createElement(s); js.id = id;
     js.src = "//connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.3&appId=808061959224601";
     fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));
    </script>
    <!--IUB-COOKIE-BLOCK-END-->

If there are HTML / IMG / IFRAME elements, you need to proceed in this way:

    <!--IUB-COOKIE-BLOCK-START-->
          <iframe src="...
          <img src="...
    <!--IUB-COOKIE-BLOCK-END-->

### Changelog

##### 1.0.2
* New: Option to block custom scripts and iframes
* Tweak: Update and extend the list of blocked scripts including Google Site Search, Google oAuth, Linkedin widgets, PayPal widgets, Freshchat, Uservoice
, AdRoll, Olark, Segment, Kissmetrics, Mixpanel, Pingdom, Bing and Elevio

##### 1.0.1
* Tweak: Update and extend the list of blocked scripts including Pinterest, AddThis, Disqus, Optimizely, Neodata, Criteo, Outbrain, Headway and Codepen

##### 1.0.0
* Initial release

### License

This project is licensed under the GPl 3 license.