<?php

class Iubenda_Cookiesolution_Model_Observer {

	public function execute( Varien_Event_Observer $observer ) {
		if ( (bool) (int) Mage::getStoreConfig( 'cookiesolution/settings/blocking_enabled', Mage::app()->getStore() ) ) {
			$iubenda_path = Mage::getBaseDir( 'app' ) . '/code/local/Iubenda/Cookiesolution/iubenda-cookie-class/';
			$response = Mage::app()->getResponse();

			$output = $response->getBody();

			require_once( $iubenda_path . 'iubenda.class.php' );

			if ( iubendaParser::consent_given() || iubendaParser::bot_detected() )
				return;

			$custom_scripts = array_filter( array_map( 'trim', explode( "\n", str_replace( "\r", '', Mage::getStoreConfig( 'cookiesolution/custom/scripts', Mage::app()->getStore() ) ) ) ) );
			$custom_iframes = array_filter( array_map( 'trim', explode( "\n", str_replace( "\r", '', Mage::getStoreConfig( 'cookiesolution/custom/iframes', Mage::app()->getStore() ) ) ) ) );

			if ( (bool) (int) Mage::getStoreConfig( 'cookiesolution/settings/experimental_mode', Mage::app()->getStore() ) )
				$iubenda = new iubendaParser( mb_convert_encoding( $output, 'HTML-ENTITIES', 'UTF-8' ), array( 'type' => 'faster', 'scripts' => $custom_scripts, 'iframes' => $custom_iframes ) );
			else
				$iubenda = new iubendaParser( $output, array( 'type' => 'page', 'scripts' => $custom_scripts, 'iframes' => $custom_iframes ) );

			// render output
			$output = $iubenda->parse();

			$response->setBody( $output );
		}
	}

}